diff --git a/module/zfs/arc.c b/module/zfs/arc.c
index 209654cbc49..8a9b2bfbac5 100644
--- a/module/zfs/arc.c
+++ b/module/zfs/arc.c
@@ -6166,7 +6166,27 @@ arc_read(zio_t *pio, spa_t *spa, const blkptr_t *bp,
 			    metadata, misses);
 		}
 
-		if (vd != NULL && l2arc_ndev != 0 && !(l2arc_norw && devw)) {
+		/*
+		 * Check if the spa even has l2 configured;
+		 *
+		 * NOTE #1: not holding spa_namespace_lock -
+		 * It should be robust to race on this field and
+		 * the very worst that can happen is an extremely
+		 * rare small mis-count of l2 stats.  This is a
+		 * tradeoff versus the overhead of aquiring
+		 * the spa_namespace_lock.
+		 *
+		 * NOTE #2: this is a quick check of whether any l2
+		 * devices are configured, NOT whether they are i.e.
+		 * in a faulted state.  Correct l2arc behavior is still
+		 * ensured by the vd!=NULL check, so a false-positive
+		 * only affects accounting.
+		 */
+		const boolean_t spa_has_l2 =
+		    l2arc_ndev != 0 &&
+		    spa->spa_l2cache.sav_count > 0;
+
+		if (vd != NULL && spa_has_l2 && !(l2arc_norw && devw)) {
 			/*
 			 * Read from the L2ARC if the following are true:
 			 * 1. The L2ARC vdev was previously cached.
@@ -6265,17 +6285,26 @@ arc_read(zio_t *pio, spa_t *spa, const blkptr_t *bp,
 				spa_config_exit(spa, SCL_L2ARC, vd);
 			}
 		} else {
+
 			if (vd != NULL)
 				spa_config_exit(spa, SCL_L2ARC, vd);
+
 			/*
-			 * Skip ARC stat bump for block pointers with
-			 * embedded data. The data are read from the blkptr
-			 * itself via decode_embedded_bp_compressed().
+			 * If the spa has no l2 then it should not contribute to
+			 * l2 miss stats.
 			 */
-			if (l2arc_ndev != 0 && !embedded_bp) {
-				DTRACE_PROBE1(l2arc__miss,
-				    arc_buf_hdr_t *, hdr);
-				ARCSTAT_BUMP(arcstat_l2_misses);
+			if (spa_has_l2) {
+				/*
+				 * Skip ARC stat bump for block pointers with
+				 * embedded data. The data are read from the
+				 * blkptr itself via
+				 * decode_embedded_bp_compressed().
+				 */
+				if (!embedded_bp) {
+					DTRACE_PROBE1(l2arc__miss,
+					    arc_buf_hdr_t *, hdr);
+					ARCSTAT_BUMP(arcstat_l2_misses);
+				}
 			}
 		}
 
